unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, OleServer, ComCtrls,
  Menus, RegisterUnit, About, optimal2dx_TLB;

type
  TForm1 = class(TForm)
    bStart: TButton;
    eSurfaceCovered: TEdit;
    Label1: TLabel;
    Image1: TImage;
    lbUsedPieces: TListBox;
    lbUnusedPieces: TListBox;
    Label6: TLabel;
    Label5: TLabel;
    lbWaste: TListBox;
    Label7: TLabel;
    sbIteration: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exiy1: TMenuItem;
    Help1: TMenuItem;
    Register1: TMenuItem;
    About1: TMenuItem;
    Optimization2DX1: TOptimization2DX;
    procedure bStartClick(Sender: TObject);
    procedure Exiy1Click(Sender: TObject);
    procedure Register1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Optimization2DX1Finish(Sender: TObject);
    procedure Optimization2DX1Progress(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Optimization2DX1AfterManualArrange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type Cut = record
     TopX : Integer; // top-left corner point
     TopY : Integer;
     BottomX : Integer; //bottom-right corner point
     BottomY : Integer;
     Thickness : Integer;
end;

type Waste = record
     TopX : Integer; // top-left corner point
     TopY : Integer;
     BottomX : Integer; //bottom-right corner point
     BottomY : Integer;
end;

type Piece = record
     TopX : Integer; // top-left corner point
     TopY : Integer;
     BottomX : Integer; //bottom-right corner point
     BottomY : Integer ;
     DemandIndex : Integer;
     ExternalIndex : Integer;
     Rotated : Integer ;
end;

type SheetInfo = record
     SheetIndex : Integer;
     length : Integer;
     width : Integer ;
     CoveredSurface : Double;
     NoCuts : Integer;
     Cuts : array of Cut;
     NoPieces : Integer;
     Pieces : array of Piece ;
     NoWastes : Integer;
     Wastes : array of Waste;
end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  iteration : integer;
    moving_piece: integer; // -1 if no piece is moving; index of the moving piece otherwise
    LastX, LastY: integer;
    MouseX, MouseY: integer;
    sheet : SheetInfo;


procedure TForm1.bStartClick(Sender: TObject);
  var
    i : integer;
begin
  bStart.Enabled := false;

  Optimization2DX1.NumberOfRepositoryPieces := 1;
  Optimization2DX1.SetRepositoryPiece(0, 300, 200, 0, 0, 0, 0, 0, 0, 0); // DO NOT modify the size of the sheet. it has the same size as the picture

  Optimization2DX1.NumberOfDemandPieces := 7;

  Optimization2DX1.SetDemandPiece(0,  60,  40,  1, 0, 0);
  Optimization2DX1.SetDemandPiece(1,  60,  40,  1, 1, 0);
  Optimization2DX1.SetDemandPiece(2,  48,  40,  1, 2, 0);
  Optimization2DX1.SetDemandPiece(3,  60,  53,  1, 3, 0);
  Optimization2DX1.SetDemandPiece(4,  45,  45,  1, 4, 0);
  Optimization2DX1.SetDemandPiece(5,  50,  80,  1, 5, 0);
  Optimization2DX1.SetDemandPiece(6,  45,  75,  1, 6, 0);

  Optimization2DX1.BladeWidth := 0;
  Optimization2DX1.OptimizationLevel := 50;
  Optimization2DX1.RandomSeed := 0;
  Optimization2DX1.MaximalCutLength := 300;

  sbIteration.SimpleText := '';

  iteration := 0;

  Optimization2DX1.StartGuillotine();   // manual arrange works for guillotine only

  // PREPARE FOR MANUAL ARRANGE

  Optimization2DX1.ManualArrangeOptimizationType := 0;
  Optimization2DX1.NumberOfRepositoryPieces := 1; // only 1 sheet (the current one) must be sent to repository
  Optimization2DX1.SetRepositoryPiece(0, 300, 200, 0, 0, 0, 0, 0, 0, 0); // do not modify the size of the sheet. it has the same size as the picture. do scale if you need other sizes

  // set all other parameters here
  Optimization2DX1.BladeWidth := 0;
  // settings of all other parameters is required

  //send all cuts back to the component
  Optimization2DX1.ManualArrangeNumberOfCuts := sheet.NoCuts;
  For i := 0 to sheet.NoCuts - 1 do
      Optimization2DX1.ManualArrangeSetCut(i, sheet.Cuts[i].TopX, sheet.Cuts[i].TopY, sheet.Cuts[i].BottomX, sheet.Cuts[i].BottomY, sheet.Cuts[i].Thickness);

  //send all piece positions back to the component
  Optimization2DX1.ManualArrangeNumberOfPieces := sheet.NoPieces;
  For i := 0 To sheet.NoPieces - 1 do
    Optimization2DX1.ManualArrangeSetPiecePosition(i, sheet.Pieces[i].TopX, sheet.Pieces[i].TopY, sheet.Pieces[i].BottomX, sheet.Pieces[i].BottomY, sheet.Pieces[i].Rotated, sheet.Pieces[i].ExternalIndex);

  //send all waste positions back to the component
  Optimization2DX1.ManualArrangeNumberOfWastes := sheet.NoWastes;
  For i := 0 To sheet.NoWastes - 1 do
    Optimization2DX1.ManualArrangeSetWasteRectangle(i, sheet.Wastes[i].TopX, sheet.Wastes[i].TopY, sheet.Wastes[i].BottomX, sheet.Wastes[i].BottomY);

  // now you can move pieces with the mouse
  ShowMessage('Move an existing piece by drag and drop. You can drop a piece on waste large enough to accept that piece.');

  bStart.Enabled := true;
end;

procedure TForm1.Exiy1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Register1Click(Sender: TObject);
begin
  if RegisterForm.ShowModal = mrOk
  then begin
    Optimization2DX1.RegisterOptimization2DX(RegisterForm.eName.Text, RegisterForm.eSerialNumber.Text);
  end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  AboutBox.lodx2ver.Caption := Optimization2DX1.Version;
  AboutBox.ShowModal;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  RegisterForm.eComputerID.Text := Optimization2DX1.ComputerID;
  moving_piece := -1;
end;

procedure TForm1.Optimization2DX1Finish(Sender: TObject);
  var
    i : integer;
    tx, ty, bx, by, thick, rotated : longint;
    poz_x, poz_y : integer;
    rep_ID, rep_Index, dem_Index, dem_ID: longint;
    sf_cov : double;
    SheetIndex : longint;

begin

  // if you want to obtain information about all sheets just iterate through all of them
  // sheets are indexed from 0 to TotalNumberOfUtilizedRepositoryPieces
  // usually the first parameter of the methods is the sheet index
  SheetIndex := 0;

  Optimization2DX1.SurfaceCovered(SheetIndex, sf_cov, rep_Index, rep_ID);
  eSurfaceCovered.Text := FloatToStr(sf_cov);
  Image1.Canvas.Rectangle(0, 0, 300, 200);

  Optimization2DX1.NumberOfCuttings(SheetIndex, sheet.NoCuts, rep_Index, rep_ID);
  SetLength(sheet.Cuts, sheet.NoCuts);

  for i := 0 to sheet.NoCuts - 1 do
  begin
    Optimization2DX1.GetCut(SheetIndex, i, tx, ty, bx, by, thick, rep_Index, rep_ID);
    Image1.Canvas.MoveTo(tx, ty);
    Image1.Canvas.LineTo(bx, by);
    sheet.Cuts[i].TopX := tx;
    sheet.Cuts[i].TopY := ty;
    sheet.Cuts[i].BottomX := bx;
    sheet.Cuts[i].BottomY := by;
    sheet.Cuts[i].Thickness := thick;
  end;

  // utilized rectagles
  Optimization2DX1.NumberOfUtilizedDemandPieces(SheetIndex, sheet.NoPieces, rep_Index, rep_ID);
  SetLength(sheet.Pieces, sheet.NoPieces);
  for i := 0 to sheet.NoPieces - 1 do
  begin
    Optimization2DX1.GetUtilizedDemandPiece(SheetIndex, i, tx, ty, bx, by, rotated, rep_Index, dem_Index, rep_ID, dem_ID);
    poz_x := (bx+tx) div 2 - Image1.Canvas.TextWidth(FloatToStr(bx-tx)+'x'+FloatToStr(by-ty)) div 2;
    poz_y := (by+ty) div 2 - Image1.Canvas.TextHeight(FloatToStr(bx-tx)+'x'+FloatToStr(by-ty)) div 2;;
    Image1.Canvas.TextOut(poz_x, poz_y, FloatToStr(abs(bx - tx)) + 'x' + FloatToStr(abs(by - ty)));
    sheet.Pieces[i].TopX := tx;
    sheet.Pieces[i].TopY := ty;
    sheet.Pieces[i].BottomX := bx;
    sheet.Pieces[i].BottomY := by;
    sheet.Pieces[i].Rotated := rotated;
    sheet.Pieces[i].ExternalIndex := dem_ID;
  end;

  // waste rectangles
  Optimization2DX1.NumberOfWastePieces(SheetIndex, sheet.NoWastes, rep_Index, rep_ID);
  SetLength(sheet.Wastes, sheet.NoWastes);
  for i := 0 to sheet.NoWastes - 1 do
  begin
    Optimization2DX1.GetWastePiece(SheetIndex, i, tx, ty, bx, by, rep_Index, rep_ID);
    lbWaste.AddItem(FloatToStr(abs(tx - bx)) + ' x ' + FloatToStr(abs(by - ty)), nil);

    poz_x := (bx + tx) div 2 - Image1.Canvas.TextWidth('w') div 2;
    poz_y := (by + ty) div 2 - Image1.Canvas.TextHeight('w') div 2;
    Image1.Canvas.TextOut(poz_x, poz_y, 'w');
    sheet.Wastes[i].TopX := tx;
    sheet.Wastes[i].TopY := ty;
    sheet.Wastes[i].BottomX := bx;
    sheet.Wastes[i].BottomY := by;
  end;

end;

procedure TForm1.Optimization2DX1AfterManualArrange(Sender: TObject);
  var
    i : integer;
    tx, ty, bx, by, thick, rotated : longint;
    poz_x, poz_y : integer;
    rep_ID, rep_Index, dem_Index, dem_ID: longint;
    sf_cov : double;
    SheetIndex : longint;

begin

  // if you want to obtain information about all sheets just iterate through all of them
  // sheets are indexed from 0 to TotalNumberOfUtilizedRepositoryPieces
  // usually the first parameter of the methods is the sheet index
  SheetIndex := 0;

  Optimization2DX1.SurfaceCovered(SheetIndex, sf_cov, rep_Index, rep_ID);
  eSurfaceCovered.Text := FloatToStr(sf_cov);
  Image1.Canvas.Rectangle(0, 0, 300, 200);

  Optimization2DX1.NumberOfCuttings(SheetIndex, sheet.NoCuts, rep_Index, rep_ID);
  SetLength(sheet.Cuts, sheet.NoCuts);

  for i := 0 to sheet.NoCuts - 1 do
  begin
    Optimization2DX1.GetCut(SheetIndex, i, tx, ty, bx, by, thick, rep_Index, rep_ID);
    Image1.Canvas.MoveTo(tx, ty);
    Image1.Canvas.LineTo(bx, by);
    // save the cuts again ... maybe some of them have been changed during manual arrange

    sheet.Cuts[i].TopX := tx;
    sheet.Cuts[i].TopY := ty;
    sheet.Cuts[i].BottomX := bx;
    sheet.Cuts[i].BottomY := by;
    sheet.Cuts[i].Thickness := thick;
  end;

  // utilized rectagles
  Optimization2DX1.NumberOfUtilizedDemandPieces(SheetIndex, sheet.NoPieces, rep_Index, rep_ID);
  SetLength(sheet.Pieces, sheet.NoPieces);
  for i := 0 to sheet.NoPieces - 1 do
  begin
    Optimization2DX1.GetUtilizedDemandPiece(SheetIndex, i, tx, ty, bx, by, rotated, rep_Index, dem_Index, rep_ID, dem_ID);
    poz_x := (bx+tx) div 2 - Image1.Canvas.TextWidth(FloatToStr(bx-tx)+'x'+FloatToStr(by-ty)) div 2;
    poz_y := (by+ty) div 2 - Image1.Canvas.TextHeight(FloatToStr(bx-tx)+'x'+FloatToStr(by-ty)) div 2;;
    Image1.Canvas.TextOut(poz_x, poz_y, FloatToStr(abs(bx - tx)) + 'x' + FloatToStr(abs(by - ty)));
    //save the pieces again ... maybe some of them have been changed during manual arrange

    sheet.Pieces[i].TopX := tx;
    sheet.Pieces[i].TopY := ty;
    sheet.Pieces[i].BottomX := bx;
    sheet.Pieces[i].BottomY := by;
    sheet.Pieces[i].Rotated := rotated;
    sheet.Pieces[i].ExternalIndex := dem_ID;
  end;

  // waste rectangles
  Optimization2DX1.NumberOfWastePieces(SheetIndex, sheet.NoWastes, rep_Index, rep_ID);
  SetLength(sheet.Wastes, sheet.NoWastes);
  for i := 0 to sheet.NoWastes - 1 do
  begin
    Optimization2DX1.GetWastePiece(SheetIndex, i, tx, ty, bx, by, rep_Index, rep_ID);
    lbWaste.AddItem(FloatToStr(abs(tx - bx)) + ' x ' + FloatToStr(abs(by - ty)), nil);

    poz_x := (bx + tx) div 2 - Image1.Canvas.TextWidth('w') div 2;
    poz_y := (by + ty) div 2 - Image1.Canvas.TextHeight('w') div 2;
    Image1.Canvas.TextOut(poz_x, poz_y, 'w');
    // save the wastes again ... maybe some of them have been changed during manual arrange

    sheet.Wastes[i].TopX := tx;
    sheet.Wastes[i].TopY := ty;
    sheet.Wastes[i].BottomX := bx;
    sheet.Wastes[i].BottomY := by;
  end;

end;

procedure TForm1.Optimization2DX1Progress(Sender: TObject);
begin
  inc(iteration);
  sbIteration.SimpleText := IntToStr(iteration);
  Application.ProcessMessages;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var
    index, i : integer;
    rc : TRect;

begin
  index := -1;
  // now I have to iterate through all pieces to see which one will be moved
  For i := 0 To sheet.NoPieces - 1 do
      If (sheet.Pieces[i].TopX < X) And (sheet.Pieces[i].TopY < Y) And (sheet.Pieces[i].BottomX > X) And (sheet.Pieces[i].BottomY > Y)
      then begin
          //i've found the piece to be moved
          index := i;
          break;
      end;

  If (index <> -1)
  then begin
    moving_piece := index; // index of the moving piece
    LastX := X; // where the mouse cursor was last time
    LastY := Y;
    MouseX := X; // where the mouse was down
    MouseY := Y;

    // draw the current moving rectangle with dots
    rc.Left := sheet.Pieces[moving_piece].TopX + LastX - MouseX;
    rc.Right := sheet.Pieces[moving_piece].BottomX - sheet.Pieces[moving_piece].TopX  + rc.Left;
    rc.Top := sheet.Pieces[moving_piece].TopY + LastY - MouseY;
    rc.Bottom := sheet.Pieces[moving_piece].BottomY - sheet.Pieces[moving_piece].TopY + rc.Top;

    Image1.Canvas.DrawFocusRect(rc);
  end
  else
      moving_piece := -1;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var
    rc : TRect;
begin
  If (moving_piece <> -1)
  then begin// only if a piece is moving

    // delete the moving oject from the previous position
    rc.Left := sheet.Pieces[moving_piece].TopX + LastX - MouseX;
    rc.Right := sheet.Pieces[moving_piece].BottomX - sheet.Pieces[moving_piece].TopX  + rc.Left;
    rc.Top := sheet.Pieces[moving_piece].TopY + LastY - MouseY;
    rc.Bottom := sheet.Pieces[moving_piece].BottomY - sheet.Pieces[moving_piece].TopY + rc.Top;

    Image1.Canvas.DrawFocusRect(rc);


    // draw the moving rectangle in the new position
    rc.Left := sheet.Pieces[moving_piece].TopX + X - MouseX;
    rc.Right := sheet.Pieces[moving_piece].BottomX - sheet.Pieces[moving_piece].TopX  + rc.Left;
    rc.Top := sheet.Pieces[moving_piece].TopY + Y - MouseY;
    rc.Bottom := sheet.Pieces[moving_piece].BottomY - sheet.Pieces[moving_piece].TopY + rc.Top;

    Image1.Canvas.DrawFocusRect(rc);

    LastX := X;
    LastY := Y;

  End;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var
    Allowed : integer;
    rc : TRect;
    
begin

  If (moving_piece <> -1)
  then begin
    rc.Left := sheet.Pieces[moving_piece].TopX + LastX - MouseX;
    rc.Right := sheet.Pieces[moving_piece].BottomX - sheet.Pieces[moving_piece].TopX  + rc.Left;
    rc.Top := sheet.Pieces[moving_piece].TopY + LastY - MouseY;
    rc.Bottom := sheet.Pieces[moving_piece].BottomY - sheet.Pieces[moving_piece].TopY + rc.Top;

    Image1.Canvas.DrawFocusRect(rc);

    //now perform the actual manual arrange with the component
    //after this operation the OnManualArrange event is raised automatically
    Optimization2DX1.ManualArrangeGuillotineMovePiece(moving_piece,
                                                      X - MouseX + sheet.Pieces[moving_piece].TopX,
                                                      Y - MouseY + sheet.Pieces[moving_piece].TopY,
                                                      X - MouseX + sheet.Pieces[moving_piece].TopX + sheet.Pieces[moving_piece].BottomX - sheet.Pieces[moving_piece].TopX,
                                                      Y - MouseY + sheet.Pieces[moving_piece].TopY + sheet.Pieces[moving_piece].BottomY - sheet.Pieces[moving_piece].TopY,
                                                      sheet.Pieces[moving_piece].Rotated,
                                                      0,
                                                      Allowed);
    If (Allowed = 1) then
        //            OK. MOVE ACCEPTED
    Else
        // MOVE NOT ACCEPTED
       ;
    moving_piece := -1; // the piece is not moving anymore
  end;
end;


end.
